<template>
  <div id="teacher_class_index_wrapper" class="bt-container">
    <h2 class="page-title">열린 강의실</h2>
    <p v-if="snapshotStatus">강사님이 학생간 화면 보기를 <b style="color: blue;">활성화</b> 하셨습니다. 내 화면은 모든 학생 및 강사님께 전송됩니다.</p>
    <p v-if="!snapshotStatus">강사님이 학생간 화면 보기를 <b style="color: red;">비활성화</b> 하셨습니다. 내 화면은 강사님께만 전송됩니다.</p>
    <p>다른 기기로 접속하거나, 새 탭을 열어서 하나 이상의 화면을 전송할 수 있습니다.</p>
    <el-row :gutter="20">
      <el-col :span="12">
        <p>내 화면</p>
        <video controls muted width="100%" ref="myVideo"/>
      </el-col>
      <el-col :span="12">
        <p>내 스냅샷</p>
        <canvas ref="myCanvas" width="180" height="180"></canvas>  
      </el-col>
    </el-row>
    <br />
    <img v-show="false" ref="myImage">
    <el-button type="primary" @click="changeVideo()">화면 변경</el-button>
    <el-button @click="openNewTab()"> 새 탭 열기 </el-button>
    
    <el-dialog
      :visible.sync="videoSelectorVisible">
      비디오 장치를 선택하세요.
      <el-table
        :data="videoList"
        highlight-current-row
        @current-change="setVideo">
        <el-table-column property="label" label="장치 이름"></el-table-column>
      </el-table>
    </el-dialog>

    <br />
    <br />

    <b>관찰할 카메라 번호: </b>
    <el-select
      v-model="cameraNumber">
      <el-option
        v-for="option in cameraNumberOptions"
        :key="option.value"
        :label="option.label"
        :value="option.value">
      </el-option>
    </el-select>

    <br />
    <br />

    <!-- <template>
      <span v-for="student in listOfStudents" :key="student.user_id">
        <span v-for="camera in student.cam" style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative"  :key="camera.socket_id">
          <i class="fa fa-circle" v-show="!camera.is_connecting" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <i class="fa fa-circle" v-show="camera.is_connecting" style="position: absolute; top: 7px; left: 15px; color:green"></i>
          <img :src="camera.src" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
        </span>
        <span v-show="student.cam.length === 0" style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative">
          <i class="fa fa-circle" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <img :src="'https://image.flaticon.com/icons/svg/167/167750.svg'" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
        </span>
      </span>
    </template> -->

    <template v-if="snapshotStatus">
      <span v-for="student in listOfStudents" :key="student.user_id">
        <span v-if="student.cam[cameraNumber-1] === undefined" style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative">
          <i class="fa fa-circle" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <img :src="'https://image.flaticon.com/icons/svg/167/167750.svg'" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
        </span>
        <span v-else style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative">
          <i class="fa fa-circle" v-show="!student.cam[cameraNumber-1].is_connecting" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <i class="fa fa-circle" v-show="student.cam[cameraNumber-1].is_connecting" style="position: absolute; top: 7px; left: 15px; color:green"></i>
          <img :src="student.cam[cameraNumber-1].src" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
          <!-- <br/>
            <el-button type="small" @click="connect(student.user_id)">{{ $t('REALTIME.TRY') }}</el-button>
          <br/> -->
        </span>
      </span>
    </template>
  </div>
</template>

<script>
import lectureService from '../../services/lectureService';
import utils from '../../utils';


export default {
  name: 'RealtimeWebcamLectureStudent',
  data() {
    return {
      videoList: [],
      videoSelectorVisible: false,

      myVideo: undefined,
      myCanvas: undefined,
      myImage: undefined,
      
      videoDeviceId: undefined,
      videoStream: undefined,

      interval: undefined,

      listOfStudents: [],
      snapshotStatus: false,
      cameraNumber: 1,
      cameraNumberOptions: [{
        value: 1,
        label: 1,
      }, {
        value: 2,
        label: 2,
      }, {
        value: 3,
        label: 3,
      }, {
        value: 4,
        label: 4,
      }, {
        value: 5,
        label: 5,
      }],
    };
  },
  async mounted() {
    const vm = this;
    vm.myVideo = vm.$refs.myVideo;
    vm.myCanvas = vm.$refs.myCanvas;
    vm.myImage = vm.$refs.myImage;
    vm.setVideo('default');

    // 소켓 연결 및 주기적으로 보내는 신호, 리스너 등록

    // 강사 - 학생 접속 관련
    const params = {
      lecture_id: vm.lectureId,
      user_id: utils.getUserIdFromJwt()
    };
    vm.sockets.subscribe("CONNECTED", () => {
      vm.$socket.emit("JOIN_LECTURE", JSON.stringify(params));
    });

    const snapshotStatus = await lectureService.getSnapshotStatus({
      lectureId: vm.lectureId,
    });

    vm.snapshotStatus = snapshotStatus.data.findResult.snapshot_share_status;

    vm.getOtherStudents();
  },
  async beforeDestory() {
    const vm = this;
    vm.interval.clearInterval();
  },
  methods: {
    async changeVideo(){
      const vm = this;
      try {
        // 비디오 목록 가져오기
        let enumeratorPromise = await navigator.mediaDevices.enumerateDevices();
        vm.videoList = enumeratorPromise.filter(x => x.kind === 'videoinput');
        vm.videoList.push({
          deviceId: null,
          label: '사용 안함',
        });
        
      } catch (err) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('REALTIME.FAILED1'),
          type: 'warning',
        });
        return;
      }
      vm.videoSelectorVisible = true;
    },
    openNewTab() {
      const vm = this;
      let routeData = vm.$router.resolve({
        path: "/a/webcamStudent" + `/${vm.$route.params.lectureId}/${vm.$route.params.classId}`,
      });
      window.open(routeData.href, "_blank");
    },
    async setVideo(arg) {
      const vm = this;
      

      if(vm.interval) {
        clearInterval(vm.interval);
      }

      if (!arg) return; // 매개변수 없이 오는 경우 (버튼 클릭 직후) 처리

      let videoConstraint = {
        deviceId: arg.deviceId,
        frameRate: { ideal: 30, max: 30 },
        width: 320,
        height: 200,
      };

      if (arg === 'default') videoConstraint.deviceId = undefined; // 최초에 아무거나 잡기 위해 사용

      vm.videoStream = await navigator.mediaDevices.getUserMedia({
        audio: true,
        video: videoConstraint,
      });
      vm.myVideo.srcObject = vm.videoStream; // TODO : 나중에 서버에서 가져오는 것으로 수정
      vm.myVideo.autoplay = true;

      vm.videoSelectorVisible = false;
        
      vm.sendSnapshot();
    },
    // 주기적 전송
    async sendSnapshot() {
      
      const vm = this;

      const context = vm.myCanvas.getContext('2d');

      vm.interval = setInterval(() => {
        context.drawImage(vm.myVideo, 0, 0, 180, 180);
        vm.myImage = vm.myCanvas.toDataURL('image/png');
        // vm.myImage.src = vm.myCanvas.toDataURL('image/png');
        if ( vm.snapshotStatus ) {
          vm.$socket.emit('SEND_SNAPSHOT', JSON.stringify({
            lecture_id: vm.lectureId,
            from: utils.getUserIdFromJwt(),
            to: 'everyone',
            snapshot: vm.myImage,
            image_type: 'main',
          }));
        }
        
      }, 3000);
    },
    // 해제된 연결 감지
    checkConnection() {
      const vm = this;
      setInterval(() => {
        const currentTime = new Date();
        vm.listOfStudents.forEach((element, index) => {
          for (let i = 0 ; i < element.cam.length ; i += 1) {
            if( i === 1 ) {
            }
            if (element.cam[i].last_shooting_time === undefined) {
              vm.$set(vm.listOfStudents[index].cam[i], 'is_connecting', false);
            } else if (currentTime - element.cam[i].last_shooting_time > 10000) {
              vm.$set(vm.listOfStudents[index].cam[i], 'is_connecting', false);
              vm.listOfStudents[index].cam.splice(i,1); // 10초 이상 신호 없으면 제거
            } else {
              vm.$set(vm.listOfStudents[index].cam[i], 'is_connecting', true);
            }
          }
        });
      }, 10000);
    },
    // 다른 학생 출석부 보기
    async getOtherStudents() {
      
      
      const vm = this;
      const listOfStudents = await lectureService.getWholeStudents({
        id: vm.$route.params.lectureId,
      });

      listOfStudents.data.forEach((element) => {
        element.cam = [];
        vm.listOfStudents.push(element);
      });


      

      // 주기적 학생 스냅샷 획득
      vm.sockets.subscribe('SEND_SNAPSHOT', (evt) => {
        
        const signal = JSON.parse(evt);

        // 탐색 후 알맞은 자리에 매핑
        vm.listOfStudents.forEach((element, index) => {
          if (element.user_id === signal.from) {
            let registered = false;
            for(let i = 0 ; i < vm.listOfStudents[index].cam.length ; i += 1) {
              if (vm.listOfStudents[index].cam[i].socket_id === signal.from_socket_id) {
                vm.$set(vm.listOfStudents[index].cam[i], 'src', signal.snapshot);
                vm.$set(vm.listOfStudents[index].cam[i], 'last_shooting_time', new Date());
                registered = true;
              }
            }
            if (registered === false) {
              let arrLength = vm.listOfStudents[index].cam.length;
              vm.listOfStudents[index].cam.push({});
              vm.$set(vm.listOfStudents[index].cam[arrLength], 'src', signal.snapshot);
              vm.$set(vm.listOfStudents[index].cam[arrLength], 'last_shooting_time', new Date());            
              vm.$set(vm.listOfStudents[index].cam[arrLength], 'socket_id', signal.from_socket_id);
            }
          }
        });
      });

      // 주기적 학생 스냅샷 획득
      vm.sockets.subscribe('SNAPSHOT_STATUS_CHANGED', (evt) => {
        
        const signal = JSON.parse(evt);
        vm.snapshotStatus = signal.status;
      });
      
      vm.checkConnection(); // 학생 스냅샷 연결 여부 확인
    }
  },
  computed: {
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
  },
  beforeDestroy() {
    const vm = this;
    clearInterval(vm.snapShotInterval);
  },
};
</script>